;;; PVS start-up file for Manip

(defvar manip-elisp-files '("pvs-prover-manip.el"))

;; Try to locate Manip directory then byte compile Manip .el files.
;; Separate subdirectories exist for Emacs and XEmacs .elc files.

(let* ((running-xemacs
	(equal (substring (symbol-name pvs-emacs-system) 0 6) "xemacs"))
       (elc-subdir (if running-xemacs "xemacs/" "emacs/"))
       (elc-path (concat "/Manip/" elc-subdir))
       (manip-dir
	(cdr (assoc "Manip" (pvs-library-path-subdirs pvs-library-path)))))
  (if manip-dir
      (dolist (f (mapcar #'(lambda (name) (concat manip-dir elc-path name))
			 manip-elisp-files))
        ;; Check if filename.el is newer than filename.elc
	(if (file-newer-than-file-p f (concat f "c"))
	    (progn (pvs-log-message "MSG" (format "Byte compiling %s" f))
		   (byte-compile-file f t)        ;; load after compiling
		   (pvs-log-message "MSG" (format "Finished compiling %s" f)))
	    (progn (load f)
		   (pvs-log-message "MSG" (format "Finished loading %s" f)))))
      ;; When the Manip directory is unknown, just try to load.
      (dolist (f (mapcar #'(lambda (name) (concat "Manip/" elc-subdir name))
			 manip-elisp-files))
	(load f)   ;; relative filename, will use load-path
	(pvs-log-message "MSG" (format "Finished loading %s" f)))))


;(require 'pvs-prover-manip)
